//+----------------------------------------------------------------------------+
//|                                                           ByMarketBuy.mq4  |
//|                                                                            |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  22.06.2008        .               |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

//-------    -------------------------------------------+
double MaxLoss                  = 200;            //   ,  
int    PersentLoss              = 0;              //     ( 0,   MaxLoss)
int    MagicNumber              = 0;              //  

bool   BySessionTime            = false;          // true -     OpenSessionTime  CloseSessionTime
string OpenSessionTime          = "09:00";
string CloseSessionTime         = "20:00";

bool   ByProfitUnderLoss        = true;           //          ProfitFactor 
double ProfitFactor             = 1;              //       

color  StopLossLineColor        = Red;            //    
color  TakeProfitLineColor      = Green;          //   

bool   ShowEdMessage            = true;           //       
bool   MarketWatch              = false;          //  
int    Slippage                 = 3;              //  
int    NumberOfTry              = 2;              //   

//-------    ---------------------------------------+
bool   gbDisabled               = False;          // 
bool   UseSound                 = false;          //   
string NameFileSound            = "expert.wav";   //   
color  clOpenBuy                = LightBlue;      //    Buy
color  clOpenSell               = LightCoral;     //    Sell

//-------    -----------------------------------------+
#include <stdlib.mqh>                             //   4


//+----------------------------------------------------------------------------+
//|  script program start function                                             |
//+----------------------------------------------------------------------------+
void start() {
  double sl=0,                       //    
         tp=0,                       //    
         Loss=0,                     //     .    
         LossReal=0,                 //     . ,    
         StopLossValue=0,            // ,        
         TakeProfitValue=0,          // ,        
         Profit=0,                   //     
         Lots=0;                     // .       
  int    Goto=0;                     //   .   OpenPosition.
  string Operation;                  //   .   MessageBox.

  //   
  double Step =MarketInfo(Symbol(),MODE_LOTSTEP);          //    . : 0.01.
  double Free=AccountFreeMargin();                         //        . : 195$.
  //double OneLot =MarketInfo(Symbol(),MODE_MARGINREQUIRED); //      . : 1000$.
  double PointSize=MarketInfo(Symbol(),MODE_POINT);        //     . : EURUSD=0.0001
  //int Pl=AccountLeverage();                                //  . : 100.
  double TickValue=MarketInfo(Symbol(), MODE_TICKVALUE);   //        1. : EURUSD=10.0$; EURGBP=14.9$
  
  //  :     
  if (PersentLoss==0) Loss=MaxLoss;
  else Loss=Free*PersentLoss/100;

  //     OpenSessionTime  CloseSessionTime   
  if (BySessionTime && OpenInTimeGap(OpenSessionTime, CloseSessionTime)==0) {
  MessageBox( ":"
             +"\n"
             +"   ..."
             , "", 0x00000000);  
  return(0);
  }
  
  //             Loss,     .  
  if (ByProfitUnderLoss && AllOrdersProfit(Loss)==0) {
  MessageBox( ":"
             +"\n"
             +"    < "+DoubleToStr(Loss, 2)
             , "", 0x00000000);  
  return(0);
  }
  
  LinesCreate();

  //      
  int  Answer = MessageBox( " SL-Red  TP-Green", " ", 0x00000001 | 0x00000040 | 0x00040000 );
  if ( Answer != 1) { deinit(); return(0); } //      "" - 
  
  //         
  sl = NormalizeDouble( ObjectGet( "StopLossLine", OBJPROP_PRICE1 ), MarketInfo( Symbol(), MODE_DIGITS ) );
  tp = NormalizeDouble( ObjectGet( "TakeProfitLine", OBJPROP_PRICE1 ), MarketInfo( Symbol(), MODE_DIGITS ) );

  //   
  if (sl<tp) {
  Operation="BUY";
  Goto=OP_BUY; 
  StopLossValue=Ask-sl;
  TakeProfitValue=tp-Ask; 
  }
     if (sl>tp) {
     Operation="SELL";
     Goto=OP_SELL; 
     StopLossValue=sl-Bid; 
     TakeProfitValue=Bid-tp; 
     }
   
  //      
  Lots=MathFloor(Loss*PointSize/StopLossValue/TickValue/Step)*Step;    //  
  LossReal=StopLossValue*Lots*TickValue/PointSize;                     //         
  Profit=TakeProfitValue*Lots*TickValue/PointSize;                     //  $

  
  //          ProfitFactor 
  if (ByProfitUnderLoss && Profit/LossReal<ProfitFactor) {
  MessageBox( ":"
             +"\n"
             +"TP("+DoubleToStr(Profit, 2)+"$) / "
             +"SL("+DoubleToStr(LossReal, 2)+"$) < "
             +"PF("+DoubleToStr(ProfitFactor, 2)+")"
             , "", 0x00000000);  

  return(0);
  }
  
  //         
  if (ShowEdMessage) {Answer = MessageBox( 
                      Operation+"\n"+
                      "------------------------------"+"\n"+                       
                      "Lots\t   "+DoubleToStr(Lots, 2)+"\n"+
                      "SL\t   "+DoubleToStr(LossReal, 2)+"$ "+"<"+DoubleToStr(Loss, 2)+"\n"+
                      "TP\t   "+DoubleToStr(Profit, 2)+"$"+"\n"+
                      "------------------------------"+"\n"+
                      "SL\t   "+DoubleToStr(sl,MarketInfo( Symbol(), MODE_DIGITS ))+" / "+
                      DoubleToStr(StopLossValue/PointSize, 0)+""+"\n"+
                      "TP\t   "+DoubleToStr(tp,MarketInfo( Symbol(), MODE_DIGITS ))+" / "+
                      DoubleToStr(TakeProfitValue/PointSize, 0)+""+"\n"+
                      "TickValue\t   "+DoubleToStr(TickValue*Lots, 2)+"$"+"\n"
                      , " ...", 0x00000001 | 0x00000040 | 0x00040000 );
  if ( Answer != 1) { deinit(); return(0); } //      "" - 
  }

  //  
  RefreshRates();
  OpenPosition(NULL, Goto, Lots, sl, tp, MagicNumber);
}

//+----------------------------------------------------------------------------+
//|  script program deinit function                                            |
//+----------------------------------------------------------------------------+
int deinit() {
  LinesDelete();
}

//+----------------------------------------------------------------------------+
//|      : my.own.st@gmail.com                                            |
//+----------------------------------------------------------------------------+
//|     : 09.03.2010                                                     |
//|   :                        |
//+----------------------------------------------------------------------------+
void LinesCreate() {
  ObjectCreate( "StopLossLine", OBJ_HLINE, 0, 0, Bid+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point, 0, 0, 0, 0 );
  ObjectSet( "StopLossLine", OBJPROP_COLOR, StopLossLineColor );
  ObjectSetText( "StopLossLine", " ", 6, "Arial", StopLossLineColor );
  		ObjectCreate( "TakeProfitLine", OBJ_HLINE, 0, 0, Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point, 0, 0, 0, 0 );
		ObjectSet( "TakeProfitLine", OBJPROP_COLOR, TakeProfitLineColor );
		ObjectSetText( "TakeProfitLine", " ", 6, "Arial", TakeProfitLineColor );
}

//+----------------------------------------------------------------------------+
//|      : my.own.st@gmail.com                                            |
//+----------------------------------------------------------------------------+
//|     : 09.03.2010                                                     |
//|   :                        |
//+----------------------------------------------------------------------------+
void LinesDelete() {
  ObjectDelete( "StopLossLine");
  ObjectDelete( "TakeProfitLine");
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 06.03.2008                                                     |
//|   :                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )           |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:         return("UnknownPeriod");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  color  cl;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 10.04.2008                                                     |
//|   :     .                            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0) {
  color    clOpen;
  datetime ot;
  double   pp, pa, pb;
  int      dg, err, it, ticket=0;
  string   lsComm=WindowExpertName()+" "+GetNameTF(Period());

  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && IsStopped()) {
      Print("OpenPosition():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, lsComm, mn, 0, CLR_NONE);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, lsComm, mn, 0, CLR_NONE);
    if (ticket>0) {
      if (UseSound) PlaySound(NameFileSound); break;
    } else {
      err=GetLastError();
      if (pa==0 && pb==0) Message("      "+sy);
      //    
//  
Alert("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
//   
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          if (UseSound) PlaySound(NameFileSound); break;
        }
      }
      if (err==140 || err==148 || err==4110 || err==4111) break;
      if (err==141) Sleep(1000*100);
      if (err==145) Sleep(1000*17);
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (err!=135) Sleep(1000*7.7);
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}

//+----------------------------------------------------------------------------+
//|      :                                                                |
//+----------------------------------------------------------------------------+
//|     : 17.03.2010                                                     |
//|   : : 1 -                |
//|                              Limit     ;    |
//|                         0 -       Limit;     |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    Limit -                          |
//+----------------------------------------------------------------------------+
bool AllOrdersProfit (double Limit) {
  int    total=OrdersTotal();                                            //  total   
  double Profit=0;                                                       //      (: 120$; -20$)
  
  if (total>0) {                                                         //    ?
      
      for(int i=total; i>=0; i--) {                                      //  ,          .
        
        if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true) {            //      ,   
          
          if (OrderType()==OP_BUY) {                                     //    BUY
          Profit=Profit+(OrderStopLoss()-OrderOpenPrice())               //         
                         /MarketInfo(Symbol(),MODE_POINT)
                         *MarketInfo(Symbol(), MODE_TICKVALUE)
                         *OrderLots();
          }

             if (OrderType()==OP_SELL) {                                 //    SELL
             Profit=Profit+(OrderOpenPrice()-OrderStopLoss())            //         
                            /MarketInfo(Symbol(),MODE_POINT)
                            *MarketInfo(Symbol(), MODE_TICKVALUE)
                            *OrderLots();
             }
        }
      }
  
  if (Profit>=Limit) return(1);                                          //       
  else return(0);
  }
  else {                                                                 //    
  return(1);
  }
}

//+----------------------------------------------------------------------------+
//|      :                                                                |
//+----------------------------------------------------------------------------+
//|     : 17.03.2010                                                     |
//|   : : 1 -     StartTime         |
//|                              FinishTime                              |
//|                         0 -           |
//+----------------------------------------------------------------------------+
bool OpenInTimeGap (string StartTime,     //  
                    string FinishTime)    //  
{
if (TimeLocal()>=StrToTime(StartTime) && TimeLocal()<=StrToTime(FinishTime)) return(1);
else return(0);
}

